<?php

/**
 * Class VI_WBOOSTSALES_Frontend_Single
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class VI_WBOOSTSALES_Frontend_Discount_Bar {
	protected $settings;
	protected $coupon;

	public function __construct() {
		$this->settings = new VI_WBOOSTSALES_Data();
		/*Check global enable*/
		if ( $this->settings->enable() ) {
			/*Check working when turn off up-sells*/
			$this->coupon = $this->settings->get_option( 'coupon' );
			if ( $this->settings->get_option( 'enable_discount' ) && ! $this->settings->get_option( 'enable_upsell' ) && $this->coupon ) {
				add_action( 'wp_footer', array( $this, 'init_bar' ) );
				add_action( 'wp_ajax_wbs_show_bar', array( $this, 'show_bar' ) );
				add_action( 'wp_ajax_nopriv_wbs_show_bar', array( $this, 'show_bar' ) );
			} elseif ( $this->settings->get_option( 'enable_upsell' ) && $this->settings->get_option( 'ajax_button' ) ) {
				add_action( 'wp_ajax_wbs_show_bar', array( $this, 'show_bar' ) );
				add_action( 'wp_ajax_nopriv_wbs_show_bar', array( $this, 'show_bar' ) );
			}
			if ( $this->coupon && $this->settings->get_option( 'enable_discount' ) ) {
				add_action( 'wp_footer', array( $this, 'apply_coupon' ) );
			}
		}
	}

	public function apply_coupon() {
		if ( is_checkout() || is_cart() ) {
			$coupon = new WC_Coupon( $this->coupon );

			if ( ! count( WC()->cart->applied_coupons ) && $coupon->is_valid() ) {
				WC()->cart->apply_coupon( $coupon->get_code() );
			}
		}
	}

	/**
	 * Show bar with ajaxt
	 */
	public function show_bar() {
		$bar = new VI_WBOOSTSALES_Discount_Bar();

		wp_send_json( $bar->show_html() );
	}

	/**
	 * Show HTML Discount bar
	 */
	public function init_bar() {
		$product_id = filter_input( INPUT_POST, 'add-to-cart', FILTER_SANITIZE_NUMBER_INT );
		$quantity   = filter_input( INPUT_POST, 'quantity', FILTER_SANITIZE_NUMBER_INT );
		if ( $product_id && $quantity ) {
			$class = 'active';
		} else {
			$class = '';
		}
		?>
		<div id="wbs-content-discount-bar" class="woocommerce-boost-sales <?php echo esc_attr( $class ) ?>"
			 style="display: none">
			<?php

			if ( $product_id && $quantity ) {
				$bar = new VI_WBOOSTSALES_Discount_Bar();

				$html = $bar->show_html();
				if ( isset( $html['html'] ) ) {
					echo $html['html'];
				}
			} ?>
		</div>
	<?php }

}